/**
  @page LTDC, FMC_SDRAM, DMA2D, DMA, TC & e.t. functionalities use example
  
  @verbatim
  ******************* (C) COPYRIGHT 2019 Peter Maltsev       ********************
  * @file    LTDC, FMC_SDRAM, DMA2D, DMA, TC /Keyboard.c 
  * @author  Peter Maltsev
  * @brief   Description of the LTDC, FMC_SDRAM, DMA2D, DMA, TC example.
  ******************************************************************************
  *  2019 
  * This is Open source software. You can place this code on your site, but don't
  * forget a link to the publication: http://pro-interes.com/category/stm32
  *     .   
  *    ,        
  * http://pro-interes.com/category/stm32
  * :   / Peter Maltsev
  * mailto: t654rk@mail.ru
  * 
  ******************************************************************************
  @endverbatim 


             
    .        
      .  Bot_Struct.xlsx.
  
              .
       ,       .
    ,    2           4.
       .
       Bot_blur_Struct.xlsx

   lcd-image-converter   .       .
         .

       flash  (      )
      .

          
       
*/


/* Includes ------------------------------------------------------------------*/
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h> //  -    printf   


#include "stm32f429i_discovery.h"       //     
#include "LTDC_BSP.h"
#include "TS_BSP.h"

#include "Keyboard.h"

   
#include "Calk_Top_ARGB.h"      //const uint32_t Calk_Top_ARGB[81920] = {...}
#include "Calk_Press_ARGB.h"    //const uint32_t Calk_Press_ARGB[81920] = {...}
#include "VLKSM_565.h"          //__ALIGN_BEGIN const uint16_t VLKSM_565[81920] = {...}    



//------------------------------------------------------------------------------
void Parm_Err(uint8_t Err); //       


//------------------------------------------------------------------------------

extern LTDC_HandleTypeDef hltdc;
extern __IO uint8_t Kbute_Opt;  //      256 

extern DMA_HandleTypeDef hdma_memtomem_dma2_stream0;
extern __IO uint32_t Transfer_DMA_flag;

extern DMA2D_HandleTypeDef hdma2d;
extern __IO uint32_t Transfer_DMA2D_flag;

extern TIM_HandleTypeDef htim7;

extern LCD_DrawPropTypeDef lcdprop;

uint16_t Kursor_Pos = 0;        //   .     

__IO uint8_t Processing_Flag = 0;       //          
__IO uint8_t Flag_Press = 1;            //        

Operation_ContentsTypeDef Calc_action = no_opt; // "/", "*", "-", "+", "%"

double Float_Operand_1 = 0;
double Float_Operand_2 = 0;
double Float_Result = 0;
double Float_Memory = 0;

uint8_t Sum_Flags_Press = 0;    //      : " "
//Attention!!!
//  Reset_Find_Flags  Key_Press_Counter = 0; Flag_Press = 1;
//           
uint8_t Key_Press_Counter = 0;  //           
int8_t Point_Flag = 0;          //   '.'
uint8_t Point_Position = 0;     //  '.'         "Backspase"
int8_t Minus_Flag = 1;          //    '-'         "Backspase"
uint8_t Minus_String_Increment = 0; //      ,     
int8_t Print_Float_Flag = 0;       //   
int8_t Print_Int_Flag = 0;         //         
int8_t EE_Fl_Flag = 0;       //       
int8_t EE_MS_Flag = 0;       //       
int8_t ERROR_Flag = 0;       //    

uint8_t L1_Blending_Flag = 0;   //      (    )

uint8_t const N_Keys = TAB_DIMENSION; //    Keyboard_Table_Init.h

static LCD_565ColorPropTypeDef lcdprop_565; //    

// BSP   ARGB.    565  
//------------------------------------------------------------------------------
void Fonts_565Color_Init(void)
{
  lcdprop_565.BackColor = FonTTF;
  lcdprop_565.TextColor = GrdTTF;
  lcdprop.pFont = &Font24;
}
//------------------------------------------------------------------------------
void Fonts_565Color_De_Init(void)
{
  lcdprop.pFont = &Font24;      // Font24 -   BSP  
}
//------------------------------------------------------------------------------
void Fonts_ARGBColor_Init(void)
{
  lcdprop.BackColor = LCD_COLOR_FonTTF;
  lcdprop.TextColor = LCD_COLOR_GrdTTF;
  lcdprop.pFont = &Font24;
}
//------------------------------------------------------------------------------
void Fonts_ARGBColor_De_Init(void)
{
  BSP_LCD_SetFont(&LCD_DEFAULT_FONT);
}

//------------------------------------------------------------------------------
void SetText_565Color(uint16_t color)
{
  lcdprop_565.TextColor = color;
}
//------------------------------------------------------------------------------
void SetBack_565Color(uint16_t color)
{
  lcdprop_565.BackColor = color;
}
//     

//       
//------------------------------------------------------------------------------
void First_Frame (void)
{
static uint16_t i = 0;

//       
  Rect_Move_DMA2D_32(Key_Layer_D, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);

//         
for(i = 255; i > 0; i--)
	{
          hdma2d.LayerCfg[1].InputAlpha = i;
          HAL_DMA2D_ConfigLayer(&hdma2d, 1);
             Transfer_DMA2D_flag = 1;
//##-3- Start DMA2D transfer ###############################################
  if (HAL_DMA2D_Start_IT(&hdma2d, (uint32_t)&VLKSM_565, FrB_Layer_1, 256, 320) == HAL_OK)
    {
      while (Transfer_DMA2D_flag);
    }
HAL_Delay(10);
        }

//Fonts_ARGBColor_Init();
//      STM32  GetPosition()
}

// Repository\STM32Cube_FW_F4_V1.21.0\Projects\STM32F429I-Discovery\Applications\Display\LTDC_Paint\Src
//  
//------------------------------------------------------------------------------
void GetPosition(void)
{
  static uint32_t x = 0, y = 0;
  static TS_StateTypeDef  TS_State;  
  
  // Get Touch screen position
  BSP_TS_GetState(&TS_State);           // TS_BSP.c
  
  // Read the coordinate
  x = Calibration_GetX(TS_State.X);     // ts_calibration.c
  y = Calibration_GetY(TS_State.Y);     // ts_calibration.c
  
//      
  
//--------------------- freeBot
if (Rect_Find_32(Key_fb, TS_State, x, y) == 1);
//--------------------- backspase
if (Rect_Find_32(Key_bs, TS_State, x, y) == 1)
    {
  if ((Key_bs->Press_F == 1)&(Processing_Flag == 0)&(Operand_Character_Counter < MAX_OPERAND_STRING)&(EE_Fl_Flag == 0)&(ERROR_Flag == 0))
        // Operand_Character_Counter > 0 -  ,      
        // Operand_Character_Counter == MAX_OPERAND_STRING -   *
        // Processing_Flag = 0; -    
        // Key_bs->Press_F = 1; -  Rect_Find_32
  {
          if (Point_Flag == 1)
      //        
        {
          if (Point_Position == (Operand_Character_Counter + 1))
            //     
          {
            Point_Flag = 0;
            Point_Position = 0;
            //   ,   
          }
        }
    *(p_Operand_String + MAX_OPERAND_STRING - ++Operand_Character_Counter + Minus_String_Increment) = 0;
    // Minus_String_Increment = 1 -     "-",   .   Operand_Character_Counter  ,
    //     
    if (Point_Flag == 1)
      //   
    {
       if (Point_Position == (Operand_Character_Counter + 1))
         //        
       {
        *(p_Operand_String + MAX_OPERAND_STRING - ++Operand_Character_Counter + Minus_String_Increment) = 0;
        //      .    !
        Point_Flag = 0;
        Point_Position = 0;
        // , ,       
       }
    }
    Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
    //   ,    
    draw_string(p_Operand_String, Key_ind, &Pf_D);
    //       
    if (Operand_Character_Counter == MAX_OPERAND_STRING)
        // *      ++Operand_Character_Counter
      {
        if (Minus_Flag < 0)
          //     ?
        {
          Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
          //   
          Minus_Flag = 1;
          // Minus_Flag = 1; - "+". Minus_Flag = -1; - "-".
          Minus_String_Increment = 0;
          //      "-"
          *(p_Operand_String) = 0;
          //  
        }
      }
    Kursor_Pos = 0;
    //   )))
    Processing_Flag = 1;
    //  .  .     .
        }
    }
//--------------------- clear_error
if (Rect_Find_32(Key_ce, TS_State, x, y) == 1)
{
  if ((Key_ce->Press_F == 1)&(Processing_Flag == 0))
        {

    *(p_Operand_String) = 0;
    Point_Flag = 0;
    Point_Position = 0;
    Minus_Flag = 1;
    Minus_String_Increment = 0;
    ERROR_Flag = 0;
    EE_Fl_Flag = 0;
    Calc_action = no_opt;
    Operand_Character_Counter = MAX_OPERAND_STRING;
    Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
    Kursor_Pos = 0;
    if (Float_Operand_1 !=0)
    {
    Result_print (Float_Operand_1);     //     
    Kursor_Pos = 0;
    }
              
    Processing_Flag = 1;
        }
    }
//--------------------- clear
if (Rect_Find_32(Key_c, TS_State, x, y) == 1)
{
  if ((Key_c->Press_F == 1)&(Processing_Flag == 0))
        {
    *(p_Operand_String) = 0;
    Point_Flag = 0;
    Point_Position = 0;
    Minus_Flag = 1;
    Minus_String_Increment = 0;
    ERROR_Flag = 0;
    EE_Fl_Flag = 0;
    Calc_action = no_opt;
    Operand_Character_Counter = MAX_OPERAND_STRING;
    Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
    Kursor_Pos = 0;
    
    Processing_Flag = 1;
        }
    }
//--------------------- memory clear
if (Rect_Find_32(Key_mc, TS_State, x, y) == 1)
{
  if ((Key_mc->Press_F == 1)&(Processing_Flag == 0))
        {
    Float_Memory = 0;
    EE_MS_Flag = 0;

    
    Processing_Flag = 1;
        }
    }
//--------------------- 7
if (Rect_Find_32(Key_n_7, TS_State, x, y) == 1)
    {
  if ((Key_n_7->Press_F == 1)&(Processing_Flag == 0)&(Operand_Character_Counter > 0)&(EE_Fl_Flag == 0)&(ERROR_Flag == 0))
        {
    // Number_input("7");
    p_Operand_String = strcat(Operand_String,"7");
    draw_string(p_Operand_String, Key_ind, &Pf_D);
    Kursor_Pos = 0;
    Operand_Character_Counter --;
    //__________________
    Processing_Flag = 1;
        }
    }
//--------------------- 8
if (Rect_Find_32(Key_n_8, TS_State, x, y) == 1)
    {
  if ((Key_n_8->Press_F == 1)&(Processing_Flag == 0)&(Operand_Character_Counter > 0)&(EE_Fl_Flag == 0)&(ERROR_Flag == 0))
        {
    Number_input("8");
    Processing_Flag = 1;
        }
    }
//--------------------- 9
if (Rect_Find_32(Key_n_9, TS_State, x, y) == 1)
    {
    if ((Key_n_9->Press_F == 1)&(Processing_Flag == 0)&(Operand_Character_Counter > 0)&(EE_Fl_Flag == 0)&(ERROR_Flag == 0))
        {
    Number_input("9");
    Processing_Flag = 1;
        }
    }
//--------------------- divide
if (Rect_Find_32(Key_div_op, TS_State, x, y) == 1)
{
  if ((Key_div_op->Press_F == 1)&(Processing_Flag == 0)&(Calc_action == no_opt)&((Point_Flag <= (MAX_OPERAND_STRING - Operand_Character_Counter))|(EE_Fl_Flag != 0))&(ERROR_Flag == 0))
    //   -           
        {
            // Operand1_string_conversion ();
            if (EE_Fl_Flag == 0)        //   (   ) ()    
            {
              if ((Point_Position - Operand_Character_Counter) == 1) //      ,   
              {
                Operand_String[++Operand_Character_Counter] = 0;
                Point_Flag = 0;
                Point_Position = 0;
              }
            Float_Operand_1 = atof(Operand_String);
            }
            else
            {
              Float_Operand_1 = Float_Result;   //         
              EE_Fl_Flag = 0;
            }
            //______________________________
            Calc_action = div_op;
    
    Start_input ();
    Processing_Flag = 1;
        }
}
//--------------------- square root
if (Rect_Find_32(Key_sqrt_op, TS_State, x, y) == 1)
{
  if ((Key_sqrt_op->Press_F == 1)&(Processing_Flag == 0)&(Calc_action == no_opt)&((Point_Flag <= (MAX_OPERAND_STRING - Operand_Character_Counter))|(EE_Fl_Flag != 0))&(ERROR_Flag == 0))
    //   -           
        {
          if (EE_Fl_Flag == 0)        //   (   ) ()    
            {
              if ((Point_Position - Operand_Character_Counter) == 1) //      ,   
              {
                Operand_String[++Operand_Character_Counter] = 0;
                Point_Flag = 0;
                Point_Position = 0;
              }
            Float_Operand_1 = atof(Operand_String);
            }
            else
            {
              Float_Operand_1 = Float_Result;   //         
              EE_Fl_Flag = 0;
            }
    if (Float_Operand_1 >= 0)
    {
    Float_Result = sqrt(Float_Operand_1);
    Result_print (Float_Result);
    Kursor_Pos = 0;
    }
    else 
    {

    Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
    draw_string("ERROR", Key_ind, &Pf_D);
    Kursor_Pos = 0;
    ERROR_Flag = 1;
    }
    
    Processing_Flag = 1;
        }
}
//--------------------- memory return/read
if (Rect_Find_32(Key_mr, TS_State, x, y) == 1)
    {
  if ((Key_mr->Press_F == 1)&(Processing_Flag == 0))
        {
    Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
    Kursor_Pos = 0;
    if (Float_Memory !=0.0)
    {
    Result_print (Float_Memory);
    Kursor_Pos = 0;
    }
    else
    {
    Start_input ();
    }
    ERROR_Flag = 0;
    Processing_Flag = 1;
        }
    }
//--------------------- 4
if (Rect_Find_32(Key_n_4, TS_State, x, y) == 1)
    {
  if ((Key_n_4->Press_F == 1)&(Processing_Flag == 0)&(Operand_Character_Counter > 0)&(EE_Fl_Flag == 0)&(ERROR_Flag == 0))
        {
    Number_input("4");
    Processing_Flag = 1;
        }
    }
//--------------------- 5
if (Rect_Find_32(Key_n_5, TS_State, x, y) == 1)
    {
  if ((Key_n_5->Press_F == 1)&(Processing_Flag == 0)&(Operand_Character_Counter > 0)&(EE_Fl_Flag == 0)&(ERROR_Flag == 0))
        {
    Number_input("5");
    Processing_Flag = 1;
        }
    }
//--------------------- 6
if (Rect_Find_32(Key_n_6, TS_State, x, y) == 1)
    {
  if ((Key_n_6->Press_F == 1)&(Processing_Flag == 0)&(Operand_Character_Counter > 0)&(EE_Fl_Flag == 0)&(ERROR_Flag == 0))
        {
    Number_input("6");
    Processing_Flag = 1;
        }
    }
//--------------------- multiply operation
if (Rect_Find_32(Key_mul_op, TS_State, x, y) == 1)
{
  if ((Key_mul_op->Press_F == 1)&(Processing_Flag == 0)&(Calc_action == no_opt)&((Point_Flag <= (MAX_OPERAND_STRING - Operand_Character_Counter))|(EE_Fl_Flag != 0))&(ERROR_Flag == 0))
    //   -           
        {
            Operand1_string_conversion ();
            Calc_action = mul_op;
    
    Start_input ();
    Processing_Flag = 1;
        }
}
//--------------------- percentage
// https://itblog21.ru/sovety/1490-kak-schitat-protsenty-na-kalkulyatore-windows
if (Rect_Find_32(Key_p_c, TS_State, x, y) == 1)
{
  if ((Key_p_c->Press_F == 1)&(Processing_Flag == 0)&((Point_Flag <= (MAX_OPERAND_STRING - Operand_Character_Counter))|(EE_Fl_Flag != 0))&(ERROR_Flag == 0))
    //   -           
        {
          switch(Calc_action)
		{
                  case div_op:  //  , Operand_2 [%].    "="   
                  {
                  Operand2_string_conversion ();        //     ( 18 %)
                  Float_Result = Float_Operand_2 / 100 + 1;     // 1,18
                  Float_Result = Float_Operand_1 / Float_Result / 100 * Float_Operand_2;
                  Calc_action = p_c_nds;
                  
    Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
    Result_print (Float_Result);
                  break;
                  }
                  
		case mul_op:    //  
                  {
                  Operand2_string_conversion ();
                  Float_Result = Float_Operand_1 / 100 * Float_Operand_2;
                  Calc_action = no_opt;
                  
    Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
    Result_print (Float_Result);
                  break;
                  }
                  
                case sub_op:    //    "="  
                  {
                  Operand2_string_conversion ();
                  Float_Result = Float_Operand_1 / 100 * Float_Operand_2;
                  Calc_action = p_c_mn;
                  
    Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
    Result_print (Float_Result);
                  break;
                  }
                  
                case add_op:    //    "="  
                  {
                  Operand2_string_conversion ();
                  Float_Result = Float_Operand_1 / 100 * Float_Operand_2;
                  Calc_action = p_c_pl;
                  
    Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
    Result_print (Float_Result);
                  break;
                  }
                }
          
    Processing_Flag = 1;
        }
}
//--------------------- memory store
if (Rect_Find_32(Key_ms, TS_State, x, y) == 1)
{
  if ((Key_ms->Press_F == 1)&(Processing_Flag == 0)&((Point_Flag <= (MAX_OPERAND_STRING - Operand_Character_Counter))|(EE_Fl_Flag != 0))&(ERROR_Flag == 0))
    //   -           
        {
          if (Calc_action == no_opt)
          {
            if (EE_Fl_Flag != 0)        //   (   ) ()   
            {
              EE_MS_Flag = 1;
            }
            else
            {
              EE_MS_Flag = 0;
            }
            Operand1_string_conversion ();      //  Float_Operand_1;       
            Float_Memory = Float_Operand_1;
          }
          else
          {
            if (EE_MS_Flag == 0)        //          
            {
            Operand2_string_conversion ();      //  Float_Operand_2;          
            Float_Memory = Float_Operand_2;
            }
          }
        
          Processing_Flag = 1;
        }
}
//--------------------- 1
if (Rect_Find_32(Key_n_1, TS_State, x, y) == 1)
    {
  if ((Key_n_1->Press_F == 1)&(Processing_Flag == 0)&(Operand_Character_Counter > 0)&(EE_Fl_Flag == 0)&(ERROR_Flag == 0))
        {
    Number_input("1");
    Processing_Flag = 1;
        }
    }
//--------------------- 2
if (Rect_Find_32(Key_n_2, TS_State, x, y) == 1)
    {
  if ((Key_n_2->Press_F == 1)&(Processing_Flag == 0)&(Operand_Character_Counter > 0)&(EE_Fl_Flag == 0)&(ERROR_Flag == 0))
        {
    Number_input("2");
    Processing_Flag = 1;
        }
    }
//--------------------- 3
if (Rect_Find_32(Key_n_3, TS_State, x, y) == 1)
    {
  if ((Key_n_3->Press_F == 1)&(Processing_Flag == 0)&(Operand_Character_Counter > 0)&(EE_Fl_Flag == 0)&(ERROR_Flag == 0))
        {
    Number_input("3");
    Processing_Flag = 1;
        }
    }
//--------------------- subtraction operation
if (Rect_Find_32(Key_sub_op, TS_State, x, y) == 1)
{
  if ((Key_sub_op->Press_F == 1)&(Processing_Flag == 0)&(Calc_action == no_opt)&((Point_Flag <= (MAX_OPERAND_STRING - Operand_Character_Counter))|(EE_Fl_Flag != 0))&(ERROR_Flag == 0))
    //   -           
        {
            Operand1_string_conversion ();
            Calc_action = sub_op;
              
    Start_input ();
    Processing_Flag = 1;
        }
}
//--------------------- inverse function
if (Rect_Find_32(Key_inv_op, TS_State, x, y) == 1)
{
  if ((Key_inv_op->Press_F == 1)&(Processing_Flag == 0)&(Calc_action == no_opt)&((Point_Flag <= (MAX_OPERAND_STRING - Operand_Character_Counter))|(EE_Fl_Flag != 0))&(ERROR_Flag == 0))
    //   -           
        {
          if (EE_Fl_Flag == 0)        //   (   ) ()    
            {
              if ((Point_Position - Operand_Character_Counter) == 1) //      ,   
              {
                Operand_String[++Operand_Character_Counter] = 0;
                Point_Flag = 0;
                Point_Position = 0;
              }
            Float_Operand_1 = atof(Operand_String);
            }
            else
            {
              Float_Operand_1 = Float_Result;   //         
              EE_Fl_Flag = 0;
            }
    if (Float_Operand_1 != 0)
    {
    Float_Result = 1/Float_Operand_1;
    Result_print (Float_Result);
    Kursor_Pos = 0;
    }
    else 
    {

    Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
    draw_string("ERROR", Key_ind, &Pf_D);
    Kursor_Pos = 0;
    ERROR_Flag = 1;
    }
    
    Processing_Flag = 1;
        }
}
//--------------------- add to memory
if (Rect_Find_32(Key_ma, TS_State, x, y) == 1)
{
  if ((Key_ma->Press_F == 1)&(Processing_Flag == 0)&((Point_Flag <= (MAX_OPERAND_STRING - Operand_Character_Counter))|(EE_Fl_Flag != 0))&(ERROR_Flag == 0))
    //   -           
        {
          if (Calc_action == no_opt)
          {
            Operand1_string_conversion ();      //  Float_Operand_1;
            Float_Memory = Float_Memory + Float_Operand_1;
          }
          else
          {
            Operand2_string_conversion ();      //  Float_Operand_2;
            Float_Memory = Float_Memory + Float_Operand_2;
          }
        
          Processing_Flag = 1;
        }
}
//--------------------- 0
if (Rect_Find_32(Key_n_0, TS_State, x, y) == 1)
    {
  if ((Key_n_0->Press_F == 1)&(Processing_Flag == 0)&(Operand_Character_Counter > 0)&(EE_Fl_Flag == 0)&(ERROR_Flag == 0))
        {
    Number_input("0");
    Processing_Flag = 1;
        }
    }
//--------------------- change the sign
if (Rect_Find_32(Key_ch_sg, TS_State, x, y) == 1)
    {
  if ((Key_ch_sg->Press_F == 1)&(Processing_Flag == 0)&(Operand_Character_Counter + 1 > 0)&(Operand_Character_Counter != MAX_OPERAND_STRING)&(EE_Fl_Flag == 0)&(ERROR_Flag == 0))
          //   "-"
          //   Operand_Character_Counter + 1 > 0,     
          //    "0"   "."   ,    Operand_Character_Counter == MAX_OPERAND_STRING
        {
        Minus_Flag = Minus_Flag * (-1);
        //   
        if (Minus_Flag < 0)
        {
          for(int i = MAX_OPERAND_STRING - Operand_Character_Counter; i >= 0; i--)
            //   
          {
            *(p_Operand_String + i + 1) = *(p_Operand_String + i);
          }
          *p_Operand_String = '-'; 
          //    "-"
          Minus_String_Increment = 1;
          // ,    
        }
        else
        {
          for(int i = 0; i <= MAX_OPERAND_STRING - Operand_Character_Counter + Minus_String_Increment; i++)
            //   
          {
            *(p_Operand_String + i) = *(p_Operand_String + i + 1);
          }
          Minus_String_Increment = 0;
          //    
          Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
          //   .  -.  .
        }
    draw_string(p_Operand_String, Key_ind, &Pf_D);
    //       
    Kursor_Pos = 0;
    //      draw_string...    Reserved
    Processing_Flag = 1;
    //  .     
        }
    }
//--------------------- decimal separator
if (Rect_Find_32(Key_d_sep, TS_State, x, y) == 1)
    {
    if ((Key_d_sep->Press_F == 1)&(Processing_Flag == 0)&(Operand_Character_Counter > 0)&(Point_Flag == 0)&(EE_Fl_Flag == 0)&(ERROR_Flag == 0))
        {
    p_Operand_String = strcat(Operand_String,".");
    draw_string(p_Operand_String, Key_ind, &Pf_D);
    Point_Flag = 1;
    Point_Position = Operand_Character_Counter;
    Kursor_Pos = 0;
    Operand_Character_Counter --;
    
    Processing_Flag = 1;
        }
    }
//--------------------- addition operation
if (Rect_Find_32(Key_add_op, TS_State, x, y) == 1)
{
  if ((Key_add_op->Press_F == 1)&(Processing_Flag == 0)&(Calc_action == no_opt)&((Point_Flag <= (MAX_OPERAND_STRING - Operand_Character_Counter))|(EE_Fl_Flag != 0))&(ERROR_Flag == 0))
    //   -           
        {
            Operand1_string_conversion ();
            Calc_action = add_op;
    
    Start_input ();   
    Processing_Flag = 1;
        }
}
//--------------------- equal sign
if (Rect_Find_32(Key_eq_sg, TS_State, x, y) == 1)
{
  if ((Key_eq_sg->Press_F == 1)&(Processing_Flag == 0)&((Point_Flag <= (MAX_OPERAND_STRING - Operand_Character_Counter))|(EE_Fl_Flag != 0))&(ERROR_Flag == 0))
    //   -           
        {
    
    switch(Calc_action)
		{
		case div_op:
                  {
                  Operand2_string_conversion ();
                  Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
                      if (Float_Operand_2 != 0)
                      {
                      Float_Result = Float_Operand_1/Float_Operand_2;
                      Result_print (Float_Result);
                      }
                      else 
                      {
                      draw_string("ERROR", Key_ind, &Pf_D);
                      Kursor_Pos = 0;
                      ERROR_Flag = 1;
                      }
                  break;
                  }
                  
                case mul_op:
                  {
                  Operand2_string_conversion ();
                  Float_Result = Float_Operand_1 * Float_Operand_2;
                  
    Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
    Result_print (Float_Result);
                  break;
                  }
                  
                case sub_op:
                  {
                  Operand2_string_conversion ();
                  Float_Result = Float_Operand_1 - Float_Operand_2;
                  
    Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
    Result_print (Float_Result);
                  break;
                  }
                  
                case add_op:
                  {
                  Operand2_string_conversion ();
                  Float_Result = Float_Operand_1 + Float_Operand_2;
                                 
    Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
    Result_print (Float_Result);
                  break;
                  }
                  
                case p_c_pl:
                  {
                  Float_Result = Float_Operand_1 + Float_Result;
                                    
    Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
    Result_print (Float_Result);
    Kursor_Pos = 0;
                  break;
                  }
    
                case p_c_mn:
                  {
                  Float_Result = Float_Operand_1 - Float_Result;
                                    
    Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
    Result_print (Float_Result);
    Kursor_Pos = 0;
                  break;
                  }
                  case p_c_nds: //  !!!   ! ))))))
                  {
                  Float_Result = Float_Operand_2 / 100 + 1;
                  Float_Result = Float_Operand_1 / Float_Result;
                                    
    Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
    Result_print (Float_Result);
    Kursor_Pos = 0;
                  break;
                  }
		}
    
    Calc_action = no_opt;
            
    Processing_Flag = 1;
        }
}

//  "".    STMPE811    .
//    .     .    , 
//             
if ((Sum_Find_Flags((uint32_t)&Keys_Table[0], N_Keys)) >= NUMBER_KEYS_GESTURE)
   {
     Rect_Move_DMA2D_32(Key_Layer_D, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
     Reset_Find_Flags((uint32_t)&Keys_Table[0], N_Keys);
          
 switch (L1_Blending_Flag)
 {
 case 0:      //  ""
     {
     for(int i = 0; i < 256; i++)
	{
            hdma2d.LayerCfg[1].InputAlpha = i;
            HAL_DMA2D_ConfigLayer(&hdma2d, 1);
               Transfer_DMA2D_flag = 1;
/*##-3- Start DMA2D transfer ###############################################*/ 
  if (HAL_DMA2D_Start_IT(&hdma2d, (uint32_t)&VLKSM_565, FrB_Layer_1, 256, 320) == HAL_OK)
    {
      while (Transfer_DMA2D_flag);
    }
HAL_Delay(1);
        }
     L1_Blending_Flag = 1;
     break;
     }
   case 1:       //  ""
     {    
for(int i = 255; i > 0; i--)
	{
          hdma2d.LayerCfg[1].InputAlpha = i;
          HAL_DMA2D_ConfigLayer(&hdma2d, 1);
             Transfer_DMA2D_flag = 1;
/*##-3- Start DMA2D transfer ###############################################*/ 
  if (HAL_DMA2D_Start_IT(&hdma2d, (uint32_t)&VLKSM_565, FrB_Layer_1, 256, 320) == HAL_OK)
    {
      while (Transfer_DMA2D_flag);
    }
HAL_Delay(1);
        }
     L1_Blending_Flag = 0;
     break;
     }
  }
 //   -    ,      
 //         
 //        'C' ()
    *(p_Operand_String) = 0;
    Point_Flag = 0;
    Point_Position = 0;
    Minus_Flag = 1;
    Minus_String_Increment = 0;
    ERROR_Flag = 0;
    EE_Fl_Flag = 0;
    Float_Operand_1 = 0;
    Float_Operand_2 = 0;
    Float_Result = 0;
    Float_Memory = 0;
    Calc_action = no_opt;
    Operand_Character_Counter = MAX_OPERAND_STRING;
    Key_Press_Counter = 0;
    Kursor_Pos = 0;
//    Flag_Press = 1;   //    Update        !!!
//    HAL_TIM_Base_Stop_IT(&htim7);    // Disable the TIM Update interrupt
    __HAL_TIM_DISABLE_IT(&htim7, TIM_IT_UPDATE);

    Processing_Flag = 0;        //   HAL_TIM_Base_Stop_IT()
    Flag_Press = 1;             //   HAL_TIM_Base_Stop_IT()
//
//    ,        
// touch screen   
//           .
//       ,     !
//    GOTO.
    }
}
//  .    ""    .       
//  .           ""   . 
//------------------------------------------------------------------------------
uint8_t Rect_Find_32(pC_Key C_Keys, TS_StateTypeDef TS_State, uint32_t x, uint32_t y)
{

uint8_t Find_flag = 0;
if ((TS_State.TouchDetected) & ( x > C_Keys->Abc_X ) & ( x < C_Keys->Abc_X +  C_Keys->Len_X)
                             & ( y > C_Keys->Ord_Y ) & ( y < C_Keys->Ord_Y +  C_Keys->Len_Y))
  {                             //   
    if (C_Keys->Press_F == 0)   //      
     {
//Attention!!!
//  Reset_Find_Flags  Key_Press_Counter = 0; Flag_Press = 1;
//           
       
       if ((Flag_Press != 0) & (Key_Press_Counter++  == 0))   //   .  
       {
        Rect_Move_DMA2D_32(C_Keys, (uint32_t)&Calk_Press_ARGB, FrB_Layer_0);    // 
//       Draw_ARGBColor_String(Key_ind, (uint32_t)FrB_Layer_0, (uint8_t*) C_Keys->Key_Name, LANDSCAPE, RIGHT_MODE);
//         -      

//______________________________________________________________________________
//      __HAL_TIM_SET_COUNTER(&htim7, htim7.Init.Period); //   
      __HAL_TIM_SET_COUNTER(&htim7, 0);
      // ((__HANDLE__)->Instance->CNT = (__COUNTER__))
      
        HAL_TIM_Base_Start_IT(&htim7);  // Enable the TIM Update interrupt, Enable the Peripheral
//__HAL_TIM_ENABLE_IT(&htim7, TIM_IT_UPDATE);
      // ((__HANDLE__)->Instance->DIER |= (__INTERRUPT__))
      // TIM_DIER_UIE           (0x1U << TIM_DIER_UIE_Pos)
//__HAL_TIM_ENABLE(&htim7);
      // ((__HANDLE__)->Instance->CR1|=(TIM_CR1_CEN))
      // TIM_CR1_CEN            (0x1U << TIM_CR1_CEN_Pos)
        
//    ,    
// TIMn->ARR   = NNN;           // 
        // TIMx_ARR    ,
        //    0  TIMx_ARR,    
        //   .
// TIMn->CR1  |= TIM_CR1_DIR;   //  ,   
// TIMn->CR1  |= TIM_CR1_ARPE;  //     
// TIMn->EGR  |= TIM_EGR_UG;    //  
// TIMn->DIER |= TIM_DIER_UIE;  //    
// TIMn->BDTR |= TIM_BDTR_MOE;  //     
// TIMn->CR1  |= TIM_CR1_CEN;   //  
//______________________________________________________________________________
        
        C_Keys->Press_F = 1;            // ,    
        Find_flag = 1;          //  
       }
       else
       {        //  ...     )))
        C_Keys->Press_F = 1;            // ,    
        Find_flag = 2;          //   
       }
     }
   }
else
   {                             //    .      ...
     if ((C_Keys->Press_F == 1)&(Flag_Press == 0))      //       
     {  //      .     "" 
      Rect_Move_DMA2D_32(C_Keys, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
      C_Keys->Press_F = 0;              // ,    
      Find_flag = 0;          //   
      if (--Key_Press_Counter == 0)     //    
      {
//       HAL_TIM_Base_Stop_IT(&htim7);    // Disable the TIM Update interrupt
     __HAL_TIM_DISABLE_IT(&htim7, TIM_IT_UPDATE);    
       //   HAL_TIM_Base_Stop_IT().  Update        !!!
       Flag_Press = 1;        //       
      }
     }
   }
  return Find_flag;
}

//   ()    .     .    , 
//             
//------------------------------------------------------------------------------
uint8_t Sum_Find_Flags(uint32_t Keys_Adr, const uint8_t n_Keys)
{
uint8_t i;
Sum_Flags_Press = 0;   //    Key_Press_Counter (    )
for (i = 1; i <= n_Keys; i++ )
{
  if (*(__IO uint16_t*) (Keys_Adr + 16 * i - 8) > 0)
  {
    Sum_Flags_Press++;  //     
  }                     //        
}
  return Sum_Flags_Press;
}

//    .
//------------------------------------------------------------------------------
void Reset_Find_Flags(uint32_t Keys_Adr, const uint8_t n_Keys)
{
uint8_t i;

Sum_Flags_Press = 0;

for (i = 1; i <= n_Keys; i++ )
    {
      *(__IO uint16_t*) (Keys_Adr + 16 * i - 8) = 0;
    }
}

//       1
void Operand1_string_conversion (void)
{
if (EE_Fl_Flag == 0)        //   (   ) ()    
            {
              if ((Point_Position - Operand_Character_Counter) == 1) //      ,   
              {
                Operand_String[++Operand_Character_Counter] = 0;
                Point_Flag = 0;
                Point_Position = 0;
              }
            Float_Operand_1 = atof(Operand_String);
            }
            else
            {
              Float_Operand_1 = Float_Result;   //         
              EE_Fl_Flag = 0;
            }
}

//       2 (      )
void Operand2_string_conversion (void)
{
if (EE_Fl_Flag == 0)        //   (   ) ()    
            {
              if ((Point_Position - Operand_Character_Counter) == 1) //      ,   
              {
                Operand_String[++Operand_Character_Counter] = 0;
                Point_Flag = 0;
                Point_Position = 0;
              }
            Float_Operand_2 = atof(Operand_String);
            }
            else
            {
              Float_Operand_2 = Float_Memory;   //         
              EE_Fl_Flag = 0;
            }
}

//  
void Number_input(char number[])
{
  p_Operand_String = strcat(Operand_String, number);
    draw_string(p_Operand_String, Key_ind, &Pf_D);
    Kursor_Pos = 0;
    Operand_Character_Counter --;
}

//             
void Start_input (void)
{
Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);
    Kursor_Pos = 0;
    *(p_Operand_String) = 0;
    Point_Flag = 0;
    Point_Position = 0;
    Minus_Flag = 1;
    Minus_String_Increment = 0;
    Operand_Character_Counter = MAX_OPERAND_STRING;
}
//------------------------------------------------------------------------------
//    ( ,  ),      
void Result_print (double Result)
{
int64_t Integer_Result = 0;

    Rect_Move_DMA2D_32(Key_ind, (uint32_t)&Calk_Top_ARGB, FrB_Layer_0);

    if ((Result > UPPER_OUTPUT_LIMIT) | (Result < -UPPER_OUTPUT_LIMIT) | ((Result < LOVER_OUTPUT_LIMIT) & (Result > 0)) | ((Result > -LOVER_OUTPUT_LIMIT) & (Result < 0)))
    {
      if (Result < 0.0)
      {
      EE_Fl_Flag =1;
      Convert_printf("%13.9E", Result);
      }
           else
           {
           EE_Fl_Flag =1;
           Convert_printf("%13.10E", Result);
           }
    }
    else 
    {
      if (fmod(Result,1) == 0.0)
        {
          Integer_Result = (int64_t)Result;
          EE_Fl_Flag = 0;
          Convert_printf("%16lld", Integer_Result);
        }
      else
      {
        Print_Float_Flag = 1;                  //   
        EE_Fl_Flag = 0;
        Result = round(Result * ROUNDING_FUNCTION_MULTIPLER) / ROUNDING_FUNCTION_MULTIPLER;
        // sqrt(2) = 1,4142135623730950488016887242097
        // DBL_MAX 1.7976931348623158e+308 Maximum value
        //    15-    ...
        //                     1.414213562373095144 * 1000000000000000 = 1414213562373095.144;
        //                     round(1414213562373095.144) = 1414213562373095;
        //                     1414213562373095 / 1000000000000000 = 1.414213562373095;
        //  9.12345678999999.  atof 9.1234567899999898
        //   .  9.1234567899999898   9.12345678999999
        //  ,    4-5       ...8(9)
        //   .999999999999999 (   ,     )
        //  .     ,    .
        Convert_printf("%16.15f", Result);
      }
    }
}
   

//  ,  ,    draw_string()       
//     
void Convert_printf(const char *args, ...)
// https://www.opennet.ru/man.shtml?topic=vsnprintf&category=3&russian=0
{
  char Result_String[100];
  char *p_Result_String = Result_String;
  
  va_list ap;   // va_list -    ,   
                //   .  ap -   argument pointer
  va_start(ap, args);   //  va_start  ap ,  
                        //     .     
                        //  ,    ap.      
                        //   ;     
                        //     
  char len = vsnprintf(Result_String, sizeof(Result_String), args, ap); // sizeof -     Result_String
  // int vsnprintf( char *s, size_t n, const char *format, va_list ap );
  //           .
  //          va list
  va_end(ap);


// -1.41421356237309'\0'
//  1.41421356237309'\0'
  if (Result_String[0] == '-')
      {
        Result_String[MAX_OPERAND_STRING + 1] = 0;    //   ,   
      }
  else
      {
        Result_String[MAX_OPERAND_STRING] = 0;    
      }
  
  
// -12.33 x 98.76 = -1218.6984
// ' ',   ' ',   ' ',   '-',   '1',   '2',   '1',  '8',   '.',   '6',   '9',   '8',   '4',   ' ',   ' ',   '\0'
  
  if (Print_Float_Flag == 1)   //    (!)
  {
Print_Float_Flag = 0;
for(int i = strlen(Result_String) - 1; i > 0; i--)
{
   if(Result_String[i] == '0')
   {
       Result_String[i] = 0;
   }
   else if(Result_String[i] == '.')
   { 
        Result_String[i] = 0;
        break;
   }
    else  break;
}
  }
// ' ',   ' ',   ' ',   '-',   '1',   '2',   '1',   '8',   '.',   '6',   '9',   '8',   '4',  '\0'  
int j = strspn(Result_String, " "); //         
for(int i = 0; i <= (int)(strlen(Result_String) - j); i++)
            //   
          {
            *(p_Result_String + i) = *(p_Result_String + i + j);
          }
// '-',   '1',   '2',   '1',   '8',   '.',   '6',   '9',   '8',   '4',    '\0'
//-------------------------------------------  
  draw_string(Result_String, Key_ind, &Pf_D);           //  .
      Kursor_Pos = 0;
      
if (EE_Fl_Flag == 0)        //        
                         {
//-------------------------------------------
  strcpy(Operand_String, Result_String);               //      .
    Operand_Character_Counter = MAX_OPERAND_STRING - strlen(Operand_String);
// '-',   '1',   '2',   '1',   '8',   '.',   '6',   '9',   '8',   '4',  '\0'
//  6      7      8      9      10     11     12     13     14     15
// Operand_Character_Counter == 6
    
      Point_Flag = 0;
      Point_Position = 0;
      if (strchr(Operand_String, '.') != NULL)
      {
        Point_Position = MAX_OPERAND_STRING - (uint32_t)(strchr(Operand_String, '.') - p_Operand_String);
// '-',   '1',   '2',   '1',   '8',   '.',   '6',   '9',   '8',   '4',  '\0'
//  6      7      8      9      10     11     12     13     14     15
// Point_Position == 11
        
        Point_Flag = 1;
      }
      
      Minus_Flag = 1;
      Minus_String_Increment = 0;
      if (Operand_String[0] == '-')     //     Result_String
      {
        Minus_Flag = -1;
        Minus_String_Increment = 1;
        ++Operand_Character_Counter;
        ++Point_Position;
//     .   Minus_String_Increment == 1
//             backspase
// Operand_Character_Counter = 7, Point_Position = 12, Minus_String_Increment = 1
      }

      
                         }
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
// https://www.riuson.com/lcd-image-converter/examples/sources
//   lcd-image-converter  STM   LTDC
//      ""   ,     
//           )))))
//

//      .
const tChar *find_char_by_code(int code, const tFont *font)
{
    int count = font->length;
    int first = 0;
    int last = count - 1;
    int mid = 0;

    if (count > 0)
    {
        if ((code >= font->chars[0].code) && (code <= font->chars[count - 1].code))
        {
            while (last >= first)
            {
                mid = first + ((last - first) / 2);

                if (font->chars[mid].code < code)
                    first = mid + 1;
                else
                    if (font->chars[mid].code > code)
                        last = mid - 1;
                    else
                        break;
            }

            if (font->chars[mid].code == code)
                return (&font->chars[mid]);
        }
    }

    return (0);
}

//             DMA2D
//       
// . .     -,   -.
//------------------------------------------------------------------------------
//       UTF-8.
//         ( 1-).
int utf8_next_char(const char *str, int index, int *resultCode, int *nextIndex)
{
    *resultCode = 0;
    unsigned char c;
    unsigned int code = 0;
    int result = 0;
    int skip = 0;
    *resultCode = 0;
    *nextIndex = -1;
        while (index >= 0)
        {
            c = *(str + index);
            index--;

            // msb
            if (skip == 0)
            {
                // if range 0x00010000-0x001fffff
                if ((c & 0xf8) == 0xf0)
                {
                    skip = 3;
                    code = c;
                }
                // if range 0x00000800-0x0000ffff
                else if ((c & 0xf0) == 0xe0)
                {
                    skip = 2;
                    code = c;
                }
                // if range 0x00000080-0x000007ff
                else if ((c & 0xe0) == 0xc0)
                {
                    skip = 1;
                    code = c;
                }
                // if range 0x00-0x7f
                else //if ((c & 0x80) == 0x00)
                {
                    skip = 0;
                    code = c;
                }
            }
            else // not msb
            {
                code = code << 8;
                code |= c;
                skip--;
            }
            if (skip == 0)
            {
                // completed
                *resultCode = code;
                *nextIndex = index;
                result = 1;
                break;
            }
        }
        return (result);
}

//------------------------------------------------------------------------------
//  .
void draw_string(const char *str, pC_Key C_Keys, const tFont *font)
{
    int len = strlen(str);
    int index = len - 1;
    int code = 0;
    int nextIndex;
    while (index >= 0)
    {
        if (utf8_next_char(str, index, &code, &nextIndex) != 0)
        {
            const tChar *ch = find_char_by_code(code, font);
            if (ch != 0)
            {
			Kursor_Pos = Num_Move_DMA2D_32(Key_ind, *(ch->image), Kursor_Pos, FrB_Layer_0);
            }
        }
        index = nextIndex;
        if (nextIndex < 0)
            break;
    }
}

//  
/*
int utf8_next_char(const char *str, int start, int *resultCode, int *nextIndex)
{
    int len = 0;
    int index = 0;
    *resultCode = 0;

    while (*(str + index) != 0)
    {
        len++;
        index++;
    }

    unsigned char c;
    unsigned int code = 0;
    int result = 0;
    int skip = 0;

    *resultCode = 0;
    *nextIndex = -1;

    if (start >= 0 && start < len)
    {
        index = start;

        while (index < len)
        {
            c = *(str + index);
            index++;

            // msb
            if (skip == 0)
            {
                // if range 0x00010000-0x001fffff
                if ((c & 0xf8) == 0xf0)
                {
                    skip = 3;
                    code = c;
                }
                // if range 0x00000800-0x0000ffff
                else if ((c & 0xf0) == 0xe0)
                {
                    skip = 2;
                    code = c;
                }
                // if range 0x00000080-0x000007ff
                else if ((c & 0xe0) == 0xc0)
                {
                    skip = 1;
                    code = c;
                }
                // if range 0x00-0x7f
                else //if ((c & 0x80) == 0x00)
                {
                    skip = 0;
                    code = c;
                }
            }
            else // not msb
            {
                code = code << 8;
                code |= c;
                skip--;
            }
            if (skip == 0)
            {
                // completed
                *resultCode = code;
                *nextIndex = index;
                result = 1;
                break;
            }
        }
    }
    return (result);
}

void draw_string(const char *str, int x, int y, const tFont *font)
{
    int len = ustrlen(str);
    int index = 0;
    int code = 0;
    int x1 = x;
    int nextIndex;
    while (index < len)
    {
        if (utf8_next_char(str, index, &code, &nextIndex) != 0)
        {
            const tChar *ch = find_char_by_code(code, font);
            if (ch != 0)
            {
                draw_bitmap_mono(x1, y, ch->image);
                x1 += ch->image->width;
            }
        }
        index = nextIndex;
        if (nextIndex < 0)
            break;
    }
}
*/
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
//   () DMA2D
// ARGB 
uint16_t Num_Move_DMA2D_32(pC_Key C_Keys, tImage Pf_D_Nums, uint16_t Kursor_Pos, uint32_t Destination_Adr)
{

//    ...   
/*
uint32_t S_Init_Mode = hdma2d.Init.Mode;                        //   
uint32_t S_LayerCfg = hdma2d.LayerCfg[1].InputColorMode;        //   DMA2D
uint32_t S_InputOffset = hdma2d.LayerCfg[1].InputOffset;
uint32_t S_OutputOffset = hdma2d.Init.OutputOffset;

uint32_t addr_source_offset = 0;
uint32_t addr_destination_offset = 0;


                      hdma2d.Init.Mode = DMA2D_M2M;
                      
                      //  ,    CM [3: 0]  DMA2D_FGPFCCR,
                      //         .
                      // if(LayerIdx == 0)
                      //   {
                      // Write DMA2D BGPFCCR register
                      // MODIFY_REG(hdma2d->Instance->BGPFCCR,..
                      // else
                      //   {
                      // Write DMA2D FGPFCCR register
                      // MODIFY_REG(hdma2d->Instance->FGPFCCR,..
                      //  :
                      hdma2d.LayerCfg[1].InputColorMode = DMA2D_INPUT_ARGB8888;
                      
                      //  DMA2D = 0
                      hdma2d.LayerCfg[1].InputOffset = 0;
                      //     ,     
                      //  DMA2D  =    * 
                      hdma2d.Init.OutputOffset = BSP_LCD_GetXSize() + Kbute_Opt - Pf_D_Nums.height;
                      
                      HAL_DMA2D_Init(&hdma2d);
                      HAL_DMA2D_ConfigLayer(&hdma2d, 1);
                      

addr_source_offset = (uint32_t)(Pf_D_Nums.data);
addr_destination_offset = Destination_Adr + 4 * ((C_Keys->Ord_Y + Kursor_Pos) * (BSP_LCD_GetXSize() + Kbute_Opt) + C_Keys->Ord_Y);

    Transfer_DMA2D_flag = 1;
    if (HAL_DMA2D_Start_IT(&hdma2d, addr_source_offset, addr_destination_offset, Pf_D_Nums.height, Pf_D_Nums.width) != HAL_OK)
    {
    // Turn LED3/LED4 on: Transfer error
    BSP_LED_On(LED3);
    BSP_LED_On(LED4);
    while(1)
      {
      }   
    }
while (Transfer_DMA2D_flag);
    {
    }
hdma2d.Init.Mode = S_Init_Mode;                        // 
hdma2d.LayerCfg[1].InputColorMode = S_LayerCfg;        //   DMA2D
hdma2d.LayerCfg[1].InputOffset = S_InputOffset;
hdma2d.Init.OutputOffset = S_OutputOffset;
HAL_DMA2D_Init(&hdma2d);
HAL_DMA2D_ConfigLayer(&hdma2d, 1);
  
  
  return Kursor_Pos + Pf_D_Nums.width;

*/

// stm32f429xx.h -  .
uint32_t S_CR = DMA2D->CR;              //   
uint32_t S_FGPFCCR = DMA2D->FGPFCCR;    //   DMA2D
uint32_t S_FGOR = DMA2D->FGOR;
uint32_t S_OOR = DMA2D->OOR;

// -
//      DMA2D     .
//  FIFO     ,   
//    ,   DMA2D_FGMAR,    ,
//  DMA2D_OMAR.
//  ,    CM [3: 0]  DMA2D_FGPFCCR,
//         .
//      DMA2D_NLR  DMA2D_FGOR
//  ,    DMA2D_NLR  DMA2D_OOR  .

DMA2D->CR &= ~DMA2D_CR_MODE_Msk;                // hdma2d.Init.Mode = DMA2D_M2M;

DMA2D->FGMAR = ((uint32_t)(Pf_D_Nums.data));     // Source_Adr
DMA2D->OMAR = Destination_Adr + 4 * ((C_Keys->Ord_Y + Kursor_Pos) * (BSP_LCD_GetXSize() + Kbute_Opt) + C_Keys->Ord_Y);

DMA2D->FGOR = 0;                                                // hdma2d.LayerCfg[N].InputOffset
//  DMA2D = 0;
//     ,     
DMA2D->OOR = BSP_LCD_GetXSize() + Kbute_Opt - Pf_D_Nums.height; // hdma2d.Init.OutputOffset
//  DMA2D  =    * 
//hdma2d.Init.OutputOffset = Lcd_Width + Kbute_Opt - len_x;

DMA2D->FGPFCCR  &= ~DMA2D_BGPFCCR_CM_Msk;                // Input color mode CM[3:0]

//    :
//hdma2d.Init.ColorMode = DMA2D_OUTPUT_RGB565;
//HAL_DMA2D_Init(&hdma2d);
//---------------------------------------
//DMA2D->OPFCCR  &= ~DMA2D_OPFCCR_CM_Msk;                 // DMA2D_OUTPUT_ARGB8888;
//      .)))

DMA2D->NLR = 0; //   -    ,
//     ,  !
DMA2D->NLR |= (Pf_D_Nums.width << DMA2D_NLR_NL_Pos) | (Pf_D_Nums.height << DMA2D_NLR_PL_Pos); // DMA2D_NLR_NL_Pos (0U)
//DMA2D_NLR_NL - Number of Lines
//DMA2D_NLR_PL - Pixel per Lines
//*       
//lcd-image-converter     ,     

    Transfer_DMA2D_flag = 1;
    
DMA2D->CR |= DMA2D_CR_TCIE_Msk;         //      
DMA2D->CR |= DMA2D_CR_START_Msk;         //  DMA2D
//HAL_DMA2D_Start_IT(&hdma2d, addr_source_offset, addr_destination_offset, len_x, len_y);


while (Transfer_DMA2D_flag);
    {
    }
    
DMA2D->CR = S_CR;              // 
DMA2D->FGPFCCR = S_FGPFCCR;    //   DMA2D
DMA2D->FGOR = S_FGOR;
DMA2D->OOR = S_OOR;


  return Kursor_Pos + Pf_D_Nums.width;
}

//  CPU RJB565
//------------------------------------------------------------------------------
void Rect_Move_16(pC_Key C_Keys, uint32_t Source_Adr, uint32_t Destination_Adr)
{
 
uint32_t Lcd_Width;
uint32_t xpos, ypos;
int16_t ord_y, abc_x, len_y, len_x;

ord_y = C_Keys->Ord_Y;
abc_x = C_Keys->Abc_X;
len_y = C_Keys->Len_Y;
len_x = C_Keys->Len_X;

// !
Lcd_Width = BSP_LCD_GetXSize(); //   BSP
//    hltdc.LayerCfg[0].ImageWidth


  for(ypos = ord_y; ypos <= (ord_y + len_y); ypos++)
  {
    for(xpos = abc_x; xpos <= (abc_x + len_x); xpos++)
    {

   *(__IO uint16_t*) (((uint32_t)Destination_Adr) + (2 * (ypos * (Lcd_Width + Kbute_Opt) + xpos))) = *(__IO uint16_t*) (((uint32_t)Source_Adr) + (2 * (ypos * (Lcd_Width + Kbute_Opt) + xpos)));

    }
  }
}

//  CPU ARGB
//------------------------------------------------------------------------------
void Rect_Move_32(pC_Key C_Keys, uint32_t Source_Adr, uint32_t Destination_Adr)
{
 
uint32_t Lcd_Width;
uint32_t xpos, ypos;
int16_t ord_y, abc_x, len_y, len_x;

ord_y = C_Keys->Ord_Y;
abc_x = C_Keys->Abc_X;
len_y = C_Keys->Len_Y;
len_x = C_Keys->Len_X;

Lcd_Width = BSP_LCD_GetXSize(); //   BSP

//------------------------------------------------------------------------------
 
  for(ypos = ord_y; ypos <= (ord_y + len_y); ypos++)
  {
    for(xpos = abc_x; xpos <= (abc_x + len_x); xpos++)
    {

   *(__IO uint32_t*) (((uint32_t)Destination_Adr) + (4 * (ypos * (Lcd_Width + Kbute_Opt) + xpos))) = *(__IO uint32_t*) (((uint32_t)Source_Adr) + (4 * (ypos * (Lcd_Width + Kbute_Opt) + xpos)));

    }
  }
}

//------------------------------------------------------------------------------
//  DMA. DataLength: The length of data to be transferred from source to destination
// RJB565              len_x + 1
//                    DMA_PDATAALIGN_HALFWORD
void Rect_Move_DMA_16(pC_Key C_Keys, uint32_t Source_Adr, uint32_t Destination_Adr)
{
//        DMA    
uint32_t Save_PeriphDataAlignment = hdma_memtomem_dma2_stream0.Init.PeriphDataAlignment;
uint32_t Save_MemDataAlignment = hdma_memtomem_dma2_stream0.Init.MemDataAlignment;
//    ,    Color_Mode,   

uint32_t Lcd_Width;
uint32_t ypos;
int16_t ord_y, abc_x, len_y, len_x;

ord_y = C_Keys->Ord_Y;
abc_x = C_Keys->Abc_X;
len_y = C_Keys->Len_Y;
len_x = C_Keys->Len_X;

Lcd_Width = BSP_LCD_GetXSize(); //   BSP


                      hdma_memtomem_dma2_stream0.Init.PeriphDataAlignment = DMA_PDATAALIGN_HALFWORD;
                      hdma_memtomem_dma2_stream0.Init.MemDataAlignment = DMA_MDATAALIGN_HALFWORD;
                      HAL_DMA_Init(&hdma_memtomem_dma2_stream0);
                     
              for(ypos = ord_y; ypos <= (ord_y + len_y); ypos++)
                 {
                  Transfer_DMA_flag = 1;
  if(HAL_DMA_Start_IT(&hdma_memtomem_dma2_stream0, ((uint32_t) Source_Adr) + (2 * (ypos * (Lcd_Width + Kbute_Opt) + abc_x)), ((uint32_t) Destination_Adr) + (2 * (ypos * (Lcd_Width + Kbute_Opt) + abc_x)), len_x + 1) != HAL_OK)
  {
    BSP_LED_On(LED3);
    BSP_LED_On(LED4);
    while(1)            // Turn LED3/LED4 on: Transfer error
    {
    }   
  }
                  while(Transfer_DMA_flag)
                        {
                        }
                 }
                      hdma_memtomem_dma2_stream0.Init.PeriphDataAlignment = Save_PeriphDataAlignment;
                      hdma_memtomem_dma2_stream0.Init.MemDataAlignment = Save_MemDataAlignment;
                      HAL_DMA_Init(&hdma_memtomem_dma2_stream0);
}

//------------------------------------------------------------------------------
//  DMA. DataLength: The length of data to be transferred from source to destination
// ARGB                len_x + 1
//                    DMA_PDATAALIGN_WORD
void Rect_Move_DMA_32(pC_Key C_Keys, uint32_t Source_Adr, uint32_t Destination_Adr)
{
//        DMA    
uint32_t Save_PeriphDataAlignment = hdma_memtomem_dma2_stream0.Init.PeriphDataAlignment;
uint32_t Save_MemDataAlignment = hdma_memtomem_dma2_stream0.Init.MemDataAlignment;
//    ,    Color_Mode,   

uint32_t Lcd_Width;
uint32_t ypos;
int16_t ord_y, abc_x, len_y, len_x;

ord_y = C_Keys->Ord_Y;
abc_x = C_Keys->Abc_X;
len_y = C_Keys->Len_Y;
len_x = C_Keys->Len_X;

Lcd_Width = BSP_LCD_GetXSize(); //   BSP

                      hdma_memtomem_dma2_stream0.Init.PeriphDataAlignment = DMA_PDATAALIGN_WORD;
                      hdma_memtomem_dma2_stream0.Init.MemDataAlignment = DMA_MDATAALIGN_WORD;
                      HAL_DMA_Init(&hdma_memtomem_dma2_stream0);
                      
              for(ypos = ord_y; ypos <= (ord_y + len_y); ypos++)
                 {
                  Transfer_DMA_flag = 1;
  if(HAL_DMA_Start_IT(&hdma_memtomem_dma2_stream0, ((uint32_t) Source_Adr) + (4 * (ypos * (Lcd_Width + Kbute_Opt) + abc_x)), ((uint32_t) Destination_Adr) + (4 * (ypos * (Lcd_Width + Kbute_Opt) + abc_x)), len_x + 1) != HAL_OK)
  {
    BSP_LED_On(LED3);
    BSP_LED_On(LED4);
    while(1)            // Turn LED3/LED4 on: Transfer error
    {
    }   
  }
                  while(Transfer_DMA_flag)
                        {
                        }
                 }
              
                      hdma_memtomem_dma2_stream0.Init.PeriphDataAlignment = Save_PeriphDataAlignment;
                      hdma_memtomem_dma2_stream0.Init.MemDataAlignment = Save_MemDataAlignment;
                      HAL_DMA_Init(&hdma_memtomem_dma2_stream0);
}

  

//------------------------------------------------------------------------------
//  DMA2D
// RJB565 
void Rect_Move_DMA2D_16(pC_Key C_Keys, uint32_t Source_Adr, uint32_t Destination_Adr)
{
uint32_t S_Init_Mode = hdma2d.Init.Mode;                        //   
uint32_t S_LayerCfg = hdma2d.LayerCfg[1].InputColorMode;        //   DMA2D
uint32_t S_InputOffset = hdma2d.LayerCfg[1].InputOffset;
uint32_t S_OutputOffset = hdma2d.Init.OutputOffset;

uint32_t Lcd_Width;
int16_t ord_y, abc_x, len_y, len_x;

uint32_t addr_source_offset = 0;
uint32_t addr_destination_offset = 0;

ord_y = C_Keys->Ord_Y;
abc_x = C_Keys->Abc_X;
len_y = C_Keys->Len_Y;
len_x = C_Keys->Len_X;

Lcd_Width = BSP_LCD_GetXSize(); //   BSP



                      hdma2d.Init.Mode = DMA2D_M2M;
                      
                      //  ,    CM [3: 0]  DMA2D_FGPFCCR,
                      //         .
                      // if(LayerIdx == 0)
                      //   {
                      // Write DMA2D BGPFCCR register
                      // MODIFY_REG(hdma2d->Instance->BGPFCCR,..
                      // else
                      //   {
                      // Write DMA2D FGPFCCR register
                      // MODIFY_REG(hdma2d->Instance->FGPFCCR,..
                      //  :
                      hdma2d.LayerCfg[1].InputColorMode = DMA2D_INPUT_RGB565;
                      
                      //  DMA2D =     
                      hdma2d.LayerCfg[1].InputOffset = Lcd_Width + Kbute_Opt - len_x;
                      //  DMA2D    .       HAL_DMA2D_ConfigLayer
                      hdma2d.Init.OutputOffset = hdma2d.LayerCfg[1].InputOffset;
                      
                      HAL_DMA2D_Init(&hdma2d);
                      HAL_DMA2D_ConfigLayer(&hdma2d, 1);
                      

addr_source_offset = Source_Adr + 2 * (ord_y * (Lcd_Width + Kbute_Opt) + abc_x);
addr_destination_offset = Destination_Adr + 2 * (ord_y * (Lcd_Width + Kbute_Opt) + abc_x);

    Transfer_DMA2D_flag = 1;
    if (HAL_DMA2D_Start_IT(&hdma2d, addr_source_offset, addr_destination_offset, len_x, len_y) != HAL_OK)
    {
    // Turn LED3/LED4 on: Transfer error
    BSP_LED_On(LED3);
    BSP_LED_On(LED4);
    while(1)
      {
      }   
    }
while (Transfer_DMA2D_flag);
    {
    }
hdma2d.Init.Mode = S_Init_Mode;                        // 
hdma2d.LayerCfg[1].InputColorMode = S_LayerCfg;        //   DMA2D
hdma2d.LayerCfg[1].InputOffset = S_InputOffset;
hdma2d.Init.OutputOffset = S_OutputOffset;
HAL_DMA2D_Init(&hdma2d);
HAL_DMA2D_ConfigLayer(&hdma2d, 1);
}
 

//------------------------------------------------------------------------------
//  DMA2D
// ARGB 
void Rect_Move_DMA2D_32(pC_Key C_Keys, uint32_t Source_Adr, uint32_t Destination_Adr)
{

uint32_t S_Init_Mode = hdma2d.Init.Mode;                        //   
uint32_t S_LayerCfg = hdma2d.LayerCfg[1].InputColorMode;        //   DMA2D
uint32_t S_InputOffset = hdma2d.LayerCfg[1].InputOffset;
uint32_t S_OutputOffset = hdma2d.Init.OutputOffset;

uint32_t Lcd_Width;
int16_t ord_y, abc_x, len_y, len_x;

uint32_t addr_source_offset = 0;
uint32_t addr_destination_offset = 0;

ord_y = C_Keys->Ord_Y;
abc_x = C_Keys->Abc_X;
len_y = C_Keys->Len_Y;
len_x = C_Keys->Len_X;

Lcd_Width = BSP_LCD_GetXSize(); //   BSP



                      hdma2d.Init.Mode = DMA2D_M2M;
                      
                      //  ,    CM [3: 0]  DMA2D_FGPFCCR,
                      //         .
                      // if(LayerIdx == 0)
                      //   {
                      // Write DMA2D BGPFCCR register
                      // MODIFY_REG(hdma2d->Instance->BGPFCCR,..
                      // else
                      //   {
                      // Write DMA2D FGPFCCR register
                      // MODIFY_REG(hdma2d->Instance->FGPFCCR,..
                      //  :
                      hdma2d.LayerCfg[1].InputColorMode = DMA2D_INPUT_ARGB8888;
                      
                      //  DMA2D =     
                      hdma2d.LayerCfg[1].InputOffset = Lcd_Width + Kbute_Opt - len_x;
                      //  DMA2D    .       HAL_DMA2D_ConfigLayer
                      hdma2d.Init.OutputOffset = hdma2d.LayerCfg[1].InputOffset;
                      
                      HAL_DMA2D_Init(&hdma2d);
                      HAL_DMA2D_ConfigLayer(&hdma2d, 1);
                      

addr_source_offset = Source_Adr + 4 * (ord_y * (Lcd_Width + Kbute_Opt) + abc_x);
addr_destination_offset = Destination_Adr + 4 * (ord_y * (Lcd_Width + Kbute_Opt) + abc_x);

    Transfer_DMA2D_flag = 1;
    if (HAL_DMA2D_Start_IT(&hdma2d, addr_source_offset, addr_destination_offset, len_x, len_y) != HAL_OK)
    {
    // Turn LED3/LED4 on: Transfer error
    BSP_LED_On(LED3);
    BSP_LED_On(LED4);
    while(1)
      {
      }   
    }
while (Transfer_DMA2D_flag);
    {
    }
hdma2d.Init.Mode = S_Init_Mode;                        // 
hdma2d.LayerCfg[1].InputColorMode = S_LayerCfg;        //   DMA2D
hdma2d.LayerCfg[1].InputOffset = S_InputOffset;
hdma2d.Init.OutputOffset = S_OutputOffset;
HAL_DMA2D_Init(&hdma2d);
HAL_DMA2D_ConfigLayer(&hdma2d, 1);

//    ...   
/*
uint32_t S_CR = DMA2D->CR;              //   
uint32_t S_FGPFCCR = DMA2D->FGPFCCR;    //   DMA2D
uint32_t S_FGOR = DMA2D->FGOR;
uint32_t S_OOR = DMA2D->OOR;

uint32_t Lcd_Width;                     //      1 
int16_t ord_y, abc_x, len_y, len_x;

ord_y = C_Keys->Ord_Y;
abc_x = C_Keys->Abc_X;
len_y = C_Keys->Len_Y;
len_x = C_Keys->Len_X;

Lcd_Width = BSP_LCD_GetXSize(); //   BSP

// -
//      DMA2D     .
//  FIFO     ,   
//    ,   DMA2D_FGMAR,    ,
//  DMA2D_OMAR.
//  ,    CM [3: 0]  DMA2D_FGPFCCR,
//         .
//      DMA2D_NLR  DMA2D_FGOR
//  ,    DMA2D_NLR  DMA2D_OOR  .

DMA2D->CR &= ~DMA2D_CR_MODE_Msk;                // hdma2d.Init.Mode = DMA2D_M2M;

DMA2D->FGMAR = Source_Adr + 4 * (ord_y * (Lcd_Width + Kbute_Opt) + abc_x);
DMA2D->OMAR = Destination_Adr + 4 * (ord_y * (Lcd_Width + Kbute_Opt) + abc_x);

DMA2D->FGOR = Lcd_Width + Kbute_Opt - len_x;            // hdma2d.LayerCfg[N].InputOffset
DMA2D->OOR = Lcd_Width + Kbute_Opt - len_x;             // hdma2d.Init.OutputOffset

DMA2D->FGPFCCR  &= ~DMA2D_BGPFCCR_CM_Msk;                // Input color mode CM[3:0]

//    :
//hdma2d.Init.ColorMode = DMA2D_OUTPUT_RGB565;
//HAL_DMA2D_Init(&hdma2d);
//---------------------------------------
//DMA2D->OPFCCR  &= ~DMA2D_OPFCCR_CM_Msk;                 // DMA2D_OUTPUT_ARGB8888;
//      .)))

DMA2D->NLR = 0; //   -    ,
//     ,  !
DMA2D->NLR |= (len_y << DMA2D_NLR_NL_Pos) | (len_x << DMA2D_NLR_PL_Pos); // DMA2D_NLR_NL_Pos (0U)

    Transfer_DMA2D_flag = 1;
    
DMA2D->CR |= DMA2D_CR_TCIE_Msk;         //      
DMA2D->CR |= DMA2D_CR_START_Msk;         //  DMA2D
//HAL_DMA2D_Start_IT(&hdma2d, addr_source_offset, addr_destination_offset, len_x, len_y);


while (Transfer_DMA2D_flag);
    {
    }
DMA2D->CR = S_CR;              // 
DMA2D->FGPFCCR = S_FGPFCCR;    //   DMA2D
DMA2D->FGOR = S_FGOR;
DMA2D->OOR = S_OOR;
*/

}
 

//------------------------------------------------------------------------------

//        RGB565  ARGB8888 DMA2D.
//    LayerIndex = 0...

//      HAL_DMA2D_Start_IT(&hdma2d, (uint32_t)&Dst_Addr, FrB_Layer_0, 256, 320) ...
//    InputOffset, OutputOffset  .
//   ,  InputOffset, OutputOffset = 0,     :
// HAL_DMA2D_Start_IT(&hdma2d, (uint32_t)&Dst_Addr, FrB_Layer_0, 120, 320);
//    ,    .  ,     .

//  :
// When the DMA2D operates in memory-to-memory mode (no pixel format conversion nor
// blending operation), only the FG FIFO is activated and acts as a buffer.
// When the DMA2D operates in memory-to-memory operation with pixel format conversion
// (no blending operation), the BG FIFO is not activated.
//  DMA2D       (   
//   ),   FG FIFO    .
//  DMA2D          
// (  ), BG FIFO  .

//       CubeMx   DMA2D_M2M_BLEND
//     
// hdma2d.LayerCfg[0].InputColorMode = DMA2D_INPUT_ARGB8888;
// hdma2d.LayerCfg[1].InputColorMode = DMA2D_INPUT_RGB565;

//    HAL_DMA2D_ConfigLayer(DMA2D_HandleTypeDef *hdma2d, uint32_t LayerIdx)
// DMA2D BGPFCR register configuration -----------------------------------
// Prepare the value to be written to the BGPFCCR register 
// regValue = pLayerCfg->InputColorMode | (pLayerCfg->AlphaMode << DMA2D_POSITION_BGPFCCR_AM) | (pLayerCfg->InputAlpha & DMA2D_BGPFCCR_ALPHA);
// Configure the background DMA2D layer
// Write DMA2D BGPFCCR register
// MODIFY_REG(hdma2d->Instance->BGPFCCR, (DMA2D_BGPFCCR_CM | DMA2D_BGPFCCR_AM | DMA2D_BGPFCCR_ALPHA), regValue);
// Configure the foreground DMA2D layer 
// DMA2D FGCOLR register configuration -------------------------------------
// Write DMA2D FGPFCCR register */
// MODIFY_REG(hdma2d->Instance->FGPFCCR, (DMA2D_BGPFCCR_CM | DMA2D_BGPFCCR_AM | DMA2D_BGPFCCR_ALPHA), regValue);

void L1_Rect_Disp_DMA2D_PFC(pC_Key C_Keys, uint32_t Source_Adr, uint16_t LayerIndex)
{
uint32_t S_InputOffset = hdma2d.LayerCfg[LayerIndex].InputOffset;
uint32_t S_OutputOffset = hdma2d.Init.OutputOffset;

uint32_t addr_source_offset = 0;
uint32_t addr_destination_offset = 0;

int16_t ord_y, abc_x, len_y, len_x;

ord_y = C_Keys->Ord_Y;
abc_x = C_Keys->Abc_X;
len_y = C_Keys->Len_Y;
len_x = C_Keys->Len_X;

Parm_Err(LayerIndex);     // LayerIndex     = {0:1)


    //  
addr_source_offset = Source_Adr + 2 * (ord_y * (hltdc.LayerCfg[LayerIndex].ImageWidth + Kbute_Opt) + abc_x);
addr_destination_offset = hltdc.LayerCfg[LayerIndex].FBStartAdress + 4 * (ord_y * (hltdc.LayerCfg[LayerIndex].ImageWidth + Kbute_Opt) + abc_x);


    //  DMA2D =     
    hdma2d.LayerCfg[LayerIndex].InputOffset = hltdc.LayerCfg[LayerIndex].ImageWidth + Kbute_Opt - len_x;
    //  DMA2D    .       HAL_DMA2D_ConfigLayer
    hdma2d.Init.OutputOffset = hdma2d.LayerCfg[LayerIndex].InputOffset;
    HAL_DMA2D_Init(&hdma2d);
    HAL_DMA2D_ConfigLayer(&hdma2d, LayerIndex);

    Transfer_DMA2D_flag = 1;
    if (HAL_DMA2D_Start_IT(&hdma2d, addr_source_offset, addr_destination_offset, len_x, len_y) != HAL_OK)
    {
    // Turn LED3/LED4 on: Transfer error
    BSP_LED_On(LED3);
    BSP_LED_On(LED4);
    while(1)
      {
      }   
    }
while (Transfer_DMA2D_flag);
    {
    }
      
    hdma2d.Init.OutputOffset = S_OutputOffset;
    hdma2d.LayerCfg[LayerIndex].InputOffset = S_InputOffset;
HAL_DMA2D_Init(&hdma2d);
HAL_DMA2D_ConfigLayer(&hdma2d, LayerIndex);
}

//        RGB565
//     ,   
//------------------------------------------------------------------------------
void Draw_565Color_Char(uint32_t Destination_Adr, uint16_t x, uint16_t y, const uint8_t c, Screen_OrientationTypedef landscape_Flag)
{
Fonts_565Color_Init();  //       16-,      BCP
        uint32_t i=0, j=0;
        uint16_t height, width;
	uint8_t offset;
	uint8_t *pchar;
        const uint8_t *ch;      //   .       .  !!!
	uint32_t line;
	ch = &lcdprop.pFont->table[(c-' ') * lcdprop.pFont->Height * ((lcdprop.pFont->Width +7) / 8)];
	height = lcdprop.pFont->Height;
	width = lcdprop.pFont->Width;
	offset = 8 * ((width + 7)/8) - width;
	for(i = 0; i < height; i++)
	{
		pchar = ((uint8_t *)ch + (width + 7)/8 * i);
		switch((width + 7)/8)
		{
		case 1:
			line = pchar[0];
			break;
		case 2:
			line = (pchar[0]<<8) | pchar[1];
			break;
		case 3:
		default:
			line = (pchar[0]<<16) | (pchar[1]<<8) | pchar[2];
			break;
		}
		for(j = 0;j < width; j++)
		{
			if(line & (1 << (width - j + offset -1)))
			{
                          if (landscape_Flag == 0) {
                                DrawPixel_565(Destination_Adr, (x+j), y, lcdprop_565.TextColor);
                                                   }
                          else {
                                DrawPixel_565(Destination_Adr, y, (x + width - j),lcdprop_565.TextColor);
                               }
			}
			else
			{
                          if (landscape_Flag == 0) {
                                DrawPixel_565(Destination_Adr, (x+j), y, lcdprop_565.BackColor);
                                                   }
                          else {
                                DrawPixel_565(Destination_Adr, y, (x + width - j), lcdprop_565.BackColor);
                               }
			}
		}
		y++;
	}
Fonts_565Color_De_Init();
}

//        ARGB
//     ,   
//------------------------------------------------------------------------------
void Draw_ARGBColor_Char(uint32_t Destination_Adr, uint16_t x, uint16_t y, const uint8_t c, Screen_OrientationTypedef landscape_Flag)
{
Fonts_ARGBColor_Init();  //        BSP
        uint32_t i=0, j=0;
        uint16_t height, width;
	uint8_t offset;
	uint8_t *pchar;
        const uint8_t *ch;      //   .       .  !!!
	uint32_t line;
	ch = &lcdprop.pFont->table[(c-' ') * lcdprop.pFont->Height * ((lcdprop.pFont->Width +7) / 8)];
	height = lcdprop.pFont->Height;
	width = lcdprop.pFont->Width;
	offset = 8 * ((width + 7)/8) - width;
	for(i = 0; i < height; i++)
	{
		pchar = ((uint8_t *)ch + (width + 7)/8 * i);
		switch((width + 7)/8)
		{
		case 1:
			line = pchar[0];
			break;
		case 2:
			line = (pchar[0]<<8) | pchar[1];
			break;
		case 3:
		default:
			line = (pchar[0]<<16) | (pchar[1]<<8) | pchar[2];
			break;
		}
		for(j = 0;j < width; j++)
		{
			if(line & (1 << (width - j + offset -1)))
			{
                          if (landscape_Flag == 0) {
                                DrawPixel_ARGB(Destination_Adr, (x+j), y, lcdprop.TextColor);
                                                   }
                          else {
                                DrawPixel_ARGB(Destination_Adr, y, (x + width - j),lcdprop.TextColor);
                               }
			}
			else
			{
                          if (landscape_Flag == 0) {
                                DrawPixel_ARGB(Destination_Adr, (x+j), y, lcdprop.BackColor);
                                                   }
                          else {
                                DrawPixel_ARGB(Destination_Adr, y, (x + width - j), lcdprop.BackColor);
                               }
			}
		}
		y++;
	}
Fonts_ARGBColor_De_Init();
}

//            RGB565
//     ,   
//------------------------------------------------------------------------------
void Draw_565Color_String(pC_Key C_Keys, uint32_t Destination_Adr, uint8_t *Text, Screen_OrientationTypedef Screen, Text_AlignModeTypdef Mode)
{
        uint16_t Y_Ar_pos = C_Keys->Ord_Y;
        uint16_t X_Ar_pos = C_Keys->Abc_X;
        uint16_t Y_Ar_SIZE = C_Keys->Len_Y;
        uint16_t X_Ar_SIZE = C_Keys->Len_X;
        uint16_t X_SIZE = BSP_LCD_GetXSize();
        uint16_t Y_SIZE = BSP_LCD_GetYSize();
        
        
        uint16_t ref_column = 1, i = 0;
	uint16_t size = 0, xsize = 0, mode_xsize = 0;
	uint8_t *ptr = Text;
        
        
	while(*ptr++) size++ ;  //  
        
        switch (Screen)
	{
		case PORTRAIT:
                {
                                Y_Ar_pos += (Y_Ar_SIZE - lcdprop.pFont->Height)/2 +1;   //    
                                xsize = (X_Ar_SIZE/lcdprop.pFont->Width);       //    
                                switch (Mode)
					{
						case CENTER_MODE:
						{
							ref_column = X_Ar_pos + ((xsize-size) * lcdprop.pFont->Width) / 2;
							break;
						}
						case LEFT_MODE:
						{
							ref_column = X_Ar_pos;
							break;
						}
						case RIGHT_MODE:
						{
							ref_column = X_Ar_pos + ((xsize-size) * lcdprop.pFont->Width);
							break;
						}
						default:
						{
							ref_column = X_Ar_pos;
							break;
						}
					}
                              
                                while ((*Text != 0) & (((X_SIZE - (i*lcdprop.pFont->Width)) & 0xFFFF) >= lcdprop.pFont->Width))
                                {
					Draw_565Color_Char(((uint32_t) Destination_Adr), ref_column, Y_Ar_pos, *Text, Screen);
					ref_column += lcdprop.pFont->Width;
					Text++;
					i++;
                                }
                                break;
                }
                case LANDSCAPE:
                {
                                X_Ar_pos += (X_Ar_SIZE - lcdprop.pFont->Height)/2 +1;   //    
//                                Y_Ar_SIZE -= 4;         //  4   
                                xsize = (Y_Ar_SIZE/lcdprop.pFont->Width);
                                mode_xsize = Y_Ar_SIZE - (lcdprop.pFont->Width * xsize);
                                switch (Mode)
					{
						case CENTER_MODE:
						{
							ref_column = Y_Ar_pos + Y_Ar_SIZE - (((xsize - size + 1) * lcdprop.pFont->Width) - mode_xsize) / 2;
							break;
						}
						case LEFT_MODE:
						{
							ref_column = Y_Ar_pos + Y_Ar_SIZE - lcdprop.pFont->Width - 1;   //    
							break;
						}
						case RIGHT_MODE:
						{
							ref_column = Y_Ar_pos + Y_Ar_SIZE - ((xsize - size + 1) * lcdprop.pFont->Width) - mode_xsize;
							break;
						}
						default:
						{
							ref_column = Y_Ar_pos + Y_Ar_SIZE - lcdprop.pFont->Width;
							break;
						}
					}
                             
                                while ((*Text != 0) & (((Y_SIZE - (i*lcdprop.pFont->Width)) & 0xFFFF) >= lcdprop.pFont->Width))
                                {
					Draw_565Color_Char(((uint32_t) Destination_Adr), ref_column, X_Ar_pos, *Text, Screen);
					ref_column -= lcdprop.pFont->Width;
					Text++;
					i++;
                                }
                                break;
                }
                default:
		{
                                Y_Ar_pos += (Y_Ar_SIZE - lcdprop.pFont->Height)/2 +1;   //    
                                xsize = (X_Ar_SIZE/lcdprop.pFont->Width);
                                switch (Mode)
					{
						case CENTER_MODE:
						{
							ref_column = X_Ar_pos + ((xsize-size) * lcdprop.pFont->Width) / 2;
							break;
						}
						case LEFT_MODE:
						{
							ref_column = X_Ar_pos;
							break;
						}
						case RIGHT_MODE:
						{
							ref_column = X_Ar_pos + ((xsize-size) * lcdprop.pFont->Width);
							break;
						}
						default:
						{
							ref_column = X_Ar_pos;
							break;
						}
					}
                              
                                while ((*Text != 0) & (((X_SIZE - (i*lcdprop.pFont->Width)) & 0xFFFF) >= lcdprop.pFont->Width))
                                {
					Draw_565Color_Char(((uint32_t) Destination_Adr), ref_column, Y_Ar_pos, *Text, PORTRAIT);
					ref_column += lcdprop.pFont->Width;
					Text++;
					i++;
                                }
                                break;
		}
        }	
}

//            ARGB
//     ,   
//------------------------------------------------------------------------------
void Draw_ARGBColor_String(pC_Key C_Keys, uint32_t Destination_Adr, uint8_t *Text, Screen_OrientationTypedef Screen, Text_AlignModeTypdef Mode)
{
        uint16_t Y_Ar_pos = C_Keys->Ord_Y;
        uint16_t X_Ar_pos = C_Keys->Abc_X;
        uint16_t Y_Ar_SIZE = C_Keys->Len_Y;
        uint16_t X_Ar_SIZE = C_Keys->Len_X;
        uint16_t X_SIZE = BSP_LCD_GetXSize();
        uint16_t Y_SIZE = BSP_LCD_GetYSize();
        
        
        uint16_t ref_column = 1, i = 0;
	uint16_t size = 0, xsize = 0, mode_xsize = 0;
	uint8_t *ptr = Text;
        
        
	while(*ptr++) size++ ;  //  
        
        switch (Screen)
	{
		case PORTRAIT:
                {
                                Y_Ar_pos += (Y_Ar_SIZE - lcdprop.pFont->Height)/2 +1;   //    
                                xsize = (X_Ar_SIZE/lcdprop.pFont->Width);       //    
                                switch (Mode)
					{
						case CENTER_MODE:
						{
							ref_column = X_Ar_pos + ((xsize-size) * lcdprop.pFont->Width) / 2;
							break;
						}
						case LEFT_MODE:
						{
							ref_column = X_Ar_pos;
							break;
						}
						case RIGHT_MODE:
						{
							ref_column = X_Ar_pos + ((xsize-size) * lcdprop.pFont->Width);
							break;
						}
						default:
						{
							ref_column = X_Ar_pos;
							break;
						}
					}
                              
                                while ((*Text != 0) & (((X_SIZE - (i*lcdprop.pFont->Width)) & 0xFFFF) >= lcdprop.pFont->Width))
                                {
					Draw_ARGBColor_Char(((uint32_t) Destination_Adr), ref_column, Y_Ar_pos, *Text, Screen);
					ref_column += lcdprop.pFont->Width;
					Text++;
					i++;
                                }
                                break;
                }
                case LANDSCAPE:
                {
                                X_Ar_pos += (X_Ar_SIZE - lcdprop.pFont->Height)/2 + 1;   //   
//                                Y_Ar_SIZE -= 4;         //  4   
                                xsize = (Y_Ar_SIZE/lcdprop.pFont->Width);
                                mode_xsize = Y_Ar_SIZE - (lcdprop.pFont->Width * xsize);
                                switch (Mode)
					{
						case CENTER_MODE:
						{
							ref_column = Y_Ar_pos + Y_Ar_SIZE - (((xsize - size + 1) * lcdprop.pFont->Width) - mode_xsize) / 2;
							break;
						}
						case LEFT_MODE:
						{
							ref_column = Y_Ar_pos + Y_Ar_SIZE - lcdprop.pFont->Width - 1;   //    
							break;
						}
						case RIGHT_MODE:
						{
							ref_column = Y_Ar_pos + Y_Ar_SIZE - ((xsize - size + 1) * lcdprop.pFont->Width) - mode_xsize;
							break;
						}
						default:
						{
							ref_column = Y_Ar_pos + Y_Ar_SIZE - lcdprop.pFont->Width;
							break;
						}
					}
                             
                                while ((*Text != 0) & (((Y_SIZE - (i*lcdprop.pFont->Width)) & 0xFFFF) >= lcdprop.pFont->Width))
                                {
					Draw_ARGBColor_Char(((uint32_t) Destination_Adr), ref_column, X_Ar_pos, *Text, Screen);
					ref_column -= lcdprop.pFont->Width;
					Text++;
					i++;
                                }
                                break;
                }
                default:
		{
                                Y_Ar_pos += (Y_Ar_SIZE - lcdprop.pFont->Height)/2 +1;   //    
                                xsize = (X_Ar_SIZE/lcdprop.pFont->Width);
                                switch (Mode)
					{
						case CENTER_MODE:
						{
							ref_column = X_Ar_pos + ((xsize-size) * lcdprop.pFont->Width) / 2;
							break;
						}
						case LEFT_MODE:
						{
							ref_column = X_Ar_pos;
							break;
						}
						case RIGHT_MODE:
						{
							ref_column = X_Ar_pos + ((xsize-size) * lcdprop.pFont->Width);
							break;
						}
						default:
						{
							ref_column = X_Ar_pos;
							break;
						}
					}
                              
                                while ((*Text != 0) & (((X_SIZE - (i*lcdprop.pFont->Width)) & 0xFFFF) >= lcdprop.pFont->Width))
                                {
					Draw_ARGBColor_Char(((uint32_t) Destination_Adr), ref_column, Y_Ar_pos, *Text, PORTRAIT);
					ref_column += lcdprop.pFont->Width;
					Text++;
					i++;
                                }
                                break;
		}
        }	
}
//------------------------------------------------------------------------------

void DrawPixel_565(uint32_t Destination_Adr, uint16_t Xpos, uint16_t Ypos, uint16_t color)
{
   *(__IO uint16_t*) (Destination_Adr + (2 * (Ypos * (BSP_LCD_GetXSize()+ Kbute_Opt) + Xpos))) = (uint16_t)color;
}
                        
//------------------------------------------------------------------------------

void DrawPixel_ARGB(uint32_t Destination_Adr, uint16_t Xpos, uint16_t Ypos, uint32_t color)
{
   *(__IO uint32_t*) (Destination_Adr + (4 * (Ypos * (BSP_LCD_GetXSize()+ Kbute_Opt) + Xpos))) = (uint32_t)color;
}
//------------------------------------------------------------------------------
//     .   0  1.
void Parm_Err(uint8_t Err)
{
if (Err > 1) {
   while (1)
     {
  /* Turn LED4 on: Parametr Error */
  BSP_LED_On(LED4);
  HAL_Delay(200);
  BSP_LED_Off(LED4);
  HAL_Delay(200);
}
}
}

















